/* 2022-07 fast pseudorandom generator */

#include <stdint.h> /* uint64_t for xorshift128plus */
// uint64_t xorshift_state[2]={0x65297742L,0x27651621L};
// 2018-08-20 add xorshift+ (better than mersenne-twister!? less mem=cache)
static uint64_t xorshift128plus(uint64_t s[2]) {
  uint64_t x = s[0];
  uint64_t const y = s[1];
  s[0] = y;
  x ^= x << 23; // a
  s[1] = x ^ y ^ (x >> 17) ^ (y >> 26); // b, c
  return s[1] + y;
}
//   stdlib.rand() is not thread-safe, but rand_r! ToDo: multithread xorshift
// usage:
//  xorshift_state[0] = srand0;
//  xorshift_state[1] = srand1;
//  for(i=0l;i<10;i++)  xorshift128plus(xorshift_state); /* shake bits */
//  printf("\nDBG: %016lx %016lx\n", xorshift_state[1], xorshift_state[0] );
//  x1= xorshift128plus(xorshift_state) & ((~((uint64_t)0))>>1);
